/*
 * Copyright (c) 2005-2010 KOM  Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.sensor.generic;

import de.tudarmstadt.maki.simonstrator.api.common.Transmitable;
import de.tudarmstadt.maki.simonstrator.api.component.overlay.OverlayContact;
import de.tudarmstadt.maki.simonstrator.api.component.sensor.generic.operation.ProcessingLog;
import de.tudarmstadt.maki.simonstrator.api.component.sensor.location.Location;

public interface DataRepresentation extends Transmitable {
	int getDataID();

	OverlayContact getRequestor();

	void setRequestor(OverlayContact pRequestor);

	Location getLocation();

	long getTimestamp();

	double getExpectationValue();

	Object getData();

	long[] getVehicleIDs();

	SensorConfiguration getSensorConfiguration();

	ProcessingLog getProcessingLog();
}
