/*
 * Copyright (c) 2005-2010 KOM  Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.sensor.generic;

import java.util.Comparator;

import de.tudarmstadt.maki.simonstrator.api.component.service.in_network_processing.AccuracyCalculation;

public class DataRepresentationComperator implements Comparator<DataRepresentation> {
	private AccuracyCalculation _accuracyCalculation;

	public DataRepresentationComperator(AccuracyCalculation pAccuracyCalculation) {
		_accuracyCalculation = pAccuracyCalculation;
	}

	@Override
	public int compare(DataRepresentation pO1, DataRepresentation pO2) {
		if (pO1 instanceof VectorBasedDataRepresentation && pO2 instanceof VectorBasedDataRepresentation) {
			VectorBasedDataRepresentation first = (VectorBasedDataRepresentation) pO1;
			VectorBasedDataRepresentation second = (VectorBasedDataRepresentation) pO2;

			if (_accuracyCalculation != null) {
				return Double.compare(_accuracyCalculation.calculateAccuracy(second),
						_accuracyCalculation.calculateAccuracy(first));
			}
		}
		return 0;
	}

}
