/*
 * Copyright (c) 2005-2010 KOM  Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.sensor.generic.operation;

import de.tudarmstadt.maki.simonstrator.api.common.Transmitable;

public class ProcessingLog implements Transmitable {
	private int _serviceID;

	private ProcessingOperation _operation;

	private ProcessingLog _firstUsedService;
	private ProcessingLog _secondUsedService;

	public ProcessingLog(int pServiceID) {
		_serviceID = pServiceID;
	}

	public ProcessingLog(int pServiceID, ProcessingLog pFirstUsedService, ProcessingLog pSecondUsedService,
			ProcessingOperation pOperation) {
		_serviceID = pServiceID;
		_firstUsedService = pFirstUsedService;
		_secondUsedService = pSecondUsedService;
		_operation = pOperation;
	}

	@Override
	public int getTransmissionSize() {
		if (_operation == null) {
			return Integer.BYTES;
		} else {
			int sum = 0;

			sum += _firstUsedService.getTransmissionSize();
			sum += _secondUsedService.getTransmissionSize();

			// For Operation Enum
			sum += Byte.BYTES;

			return sum;
		}
	}

	public ProcessingLog getFirstUsedService() {
		return _firstUsedService;
	}

	public ProcessingLog getSecondUsedService() {
		return _secondUsedService;
	}

	public ProcessingOperation getOperation() {
		return _operation;
	}

	public int getServiceID() {
		return _serviceID;
	}

}
