package de.tudarmstadt.maki.simonstrator.api.component.vehicular.data.map;

import de.tudarmstadt.maki.simonstrator.api.component.sensor.location.Location;

public class IntegralSensorValueMap implements SensorValueMap {

	private SensorValueMap _basisMap;

	public IntegralSensorValueMap(double pMean, double pMax, double pTemporalChange, double pGeographicalChange,
			double pWorldWidth, double pWorldHeight) {
		_basisMap = new ComplexSensorValueMap(pMean, pMax, pTemporalChange, pGeographicalChange, pWorldWidth,
				pWorldHeight);
	}

	@Override
	public double getValueAt(Location pLocation) {
		return (int) Math.round(_basisMap.getValueAt(pLocation));
	}

	@Override
	public double getValueAt(Location pLocation, long pTimestamp) {
		double value = _basisMap.getValueAt(pLocation, pTimestamp);
		if (value != Double.NEGATIVE_INFINITY) {
			return (int) Math.round(value);
		} else {
			return value;
		}
	}

	@Override
	public double getMaxValue() {
		return _basisMap.getMaxValue();
	}
}
